clear all
close all
l = 1;
g = 9.81;
theta0 = pi/4;
t0 = 0;
tstar = pi * sqrt(l/g) - t0;
m = 100;
k = tstar / m;
y0 = [theta0;0];
y = zeros(2,m+1);
y(:,1) = y0;
tol = k^2 / 10;
J = @(x) eye(2)-k/2*[0,1;-g*cos(x(1))/l,0];
for n = 1:m
  F = @(x) x-y(:,n)-k/2*[y(2,n);-g*sin(y(1,n))/l]-k/2*[x(2);-g*sin(x(1))/l];
  x = y(:,n);
  errest = -J(x)\F(x);
  while (norm(errest,Inf) > tol)
    x = x+errest;
    errest = -J(x)\F(x);
  end  
  y(:,n+1) = x;
end
t = linspace(t0,t0+tstar,m+1);
plot(t,y(1,:),t,theta0*cos(sqrt(g/l)*t))
legend('pendolo','pendolo linearizzato')
m1 = 100;
m = m1;
y = [theta0;0];
k = tstar / m;
for n = 1:m
  y = y+k*[y(2);-g*y(1)/l];
end
f1 = abs(y(1)-theta0*cos(sqrt(g/l)*tstar))-1e-2;
m2 = 500;
m = m2;
y = [theta0;0];
k = tstar / m;
for n = 1:m
  y = y+k*[y(2);-g*y(1)/l];
end
f2 = abs(y(1)-theta0*cos(sqrt(g/l)*tstar))-1e-2;
% bisezione
if (f1 * f2 > 0)
  error('cambia m1 o m2')
end
m = ceil((m1+m2)/2);
delta = floor((m2 - m1) / 2);
while (delta > 0)
  y = [theta0;0];
  k = tstar / m;
  for n = 1:m
    y = y+k*[y(2);-g*y(1)/l];
  end
  f = abs(y(1)-theta0*cos(sqrt(g/l)*tstar))-1e-2;
  if (f * f1 < 0)
    m2 = m;
  else
    m1 = m;
    f1 = f;
  end
  m = ceil((m1+m2)/2);
  delta = floor((m2 - m1) /2);
end
m