clear all
t0 = 0;
tstar = 15-t0;
m1 = 300;
m = m1;
k = tstar / m;
y0 = [0.5;2;10];
y = zeros(3,m+1);
y(:,1) = y0;
J = @(x) eye(3)-k*[-2*x(2),-2*x(1),0;...
		   2*x(1),-2*x(2),2*x(3);...
		   -2*x(3),-2*x(3),-2*(x(2)+x(1))];
tol = k / 10;
for n = 1:m
  F = @(x) x-y(:,n)-k*[-2*x(2)*x(1);x(1)^2+x(3)^2-x(2)^2-1;-2*(x(2)+x(1))*x(3)];
  x = y(:,n);
  errest = -J(x)\F(x);
  while (norm(errest,inf) > tol)
    x = x+errest;
    errest = -J(x)\F(x);
  end
  y(:,n+1) = x;
end
t1 = linspace(t0,tstar,m+1);
E1 = (y(1,:).^2+y(2,:).^2+y(3,:).^2+1)./(2*y(1,:));
m2 = 900;
m = m2;
k = tstar / m;
y0 = [0.5;2;10];
y = zeros(3,m+1);
y(:,1) = y0;
J = @(x) eye(3)-k*[-2*x(2),-2*x(1),0;...
		   2*x(1),-2*x(2),2*x(3);...
		   -2*x(3),-2*x(3),-2*(x(2)+x(1))];
tol = k / 10;
for n = 1:m
  F = @(x) x-y(:,n)-k*[-2*x(2)*x(1);x(1)^2+x(3)^2-x(2)^2-1;-2*(x(2)+x(1))*x(3)];
  x = y(:,n);
  errest = -J(x)\F(x);
  while (norm(errest,inf) > tol)
    x = x+errest;
    errest = -J(x)\F(x);
  end
  y(:,n+1) = x;
end
t2 = linspace(t0,tstar,m+1);
E2 = (y(1,:).^2+y(2,:).^2+y(3,:).^2+1)./(2*y(1,:));
plot(t1,E1,t2,E2)
legend('m = 300','m = 900')